﻿namespace Singleton
{
    internal class Program
    {
        enum KtóraInstancja { Żadna, Pierwsza, Druga }

        class Log //singleton
        {
            #region Singleton
            private static Log? instancja1 = null;
            private static Log? instancja2 = null;

            private static KtóraInstancja któraInstancja = KtóraInstancja.Żadna;

            public static Log Instancja
            {
                get
                {
                    switch (któraInstancja)
                    {
                        case KtóraInstancja.Żadna:
                        case KtóraInstancja.Druga:
                            if (instancja1 == null) instancja1 = new Log();
                            któraInstancja = KtóraInstancja.Pierwsza;
                            return instancja1;
                        case KtóraInstancja.Pierwsza:
                            if (instancja2 == null) instancja2 = new Log();
                            któraInstancja = KtóraInstancja.Druga;
                            return instancja2;
                        default:
                            throw new Exception("Tak nie może być!");
                    }
                }
            }

            private Log()
            {
                Console.WriteLine("Rejestr zdarzeń został utworzony");
            }
            #endregion

            #region Rejestr zdarzeń
            private List<string> komunikaty = new List<string>();

            public void Dodaj(string komunikat)
            {
                komunikaty.Add(DateTime.Now.ToString() + " - " + komunikat);
            }

            private const string nazwaPliku1 = "log1.txt", nazwaPliku2 = "log2.txt";

            public void Zapisz()
            {
                try
                {
                    //powinno być Apend
                    if (instancja1 != null) File.WriteAllLines(nazwaPliku1, instancja1.komunikaty);
                    if (instancja2 != null) File.WriteAllLines(nazwaPliku2, instancja2.komunikaty);
                }
                catch(Exception exc)
                {
                    throw new Exception("Błąd podczas zapisu pliku", exc);
                }
            }
            #endregion
        }

        static void Main(string[] args)
        {
            Log.Instancja.Dodaj("Uruchomienie aplikacji");

            new DalekaIGłębokaKlasa().Metoda();

            Log.Instancja.Dodaj("Zamykanie aplikacji");
            Log.Instancja.Zapisz();
        }

        class DalekaIGłębokaKlasa
        {
            public void Metoda()
            {
                Log.Instancja.Dodaj("DalekaKlasa.Metoda");
            }
        }
    }
}
